import { reactive, Ref, ref } from 'vue';
import skTableProps from '../props';
import { defineProps } from 'vue';
import { Sort } from '../type';
const propsType = defineProps({ ...skTableProps });
type Props = typeof propsType;
const useQueryParams = (props: Props) => {
  // 分页参数
  const pageParams = reactive({
    pageSize: 15,
    pageNum: 1,
    total: 0,
  });
  //   默认筛选参数
  const defaultParams = props.queryParams ? props.queryParams : {};
  // 筛选项
  const filterParams: Ref<Record<string, unknown>> = ref({});
  const searchParams: Ref<Record<string, unknown>> = ref({});
  const sortParams: Sort = reactive({
    // sortType: null,
    // sortColumnCn: null,
  });
  /**获取表格查询参数 */
  const getTableParams = (params: Record<string, unknown> = {}) => {
    let queryParams = {
      ...defaultParams,
      ...sortParams,
      ...filterParams.value,
      ...searchParams.value,
      ...params,
    };
    // if (props.search) {
    //   params[props.searchConfig.prop] = cloneParams[props.searchConfig.prop];
    // }
    // 分页处理
    if (props.isPage || props.isScroll) {
      let { pageSize, pageNum } = pageParams;
      queryParams = Object.assign(queryParams, {
        pageSize,
        pageNum,
      });
    }
    // 不显示分页，但是是分页数据,
    if (!props.showPage && props.isScroll === false) {
      queryParams['pageSize'] = 99999999;
    }
    return queryParams;
  };
  return {
    getTableParams,
    sortParams,
    filterParams,
    pageParams,
    searchParams,
    defaultParams,
  };
};
export default useQueryParams;
