import { ErpTableOptions } from '@/types/type';
import { text } from 'stream/consumers';
import { PropType } from 'vue';
import tableProps from 'vxe-table/packages/table/src/props';
import { SearchConfig } from '../type';
const skTableProps = {
  ...tableProps,
  data: {
    type: Array as PropType<any[]>,
    default: () => {
      return null;
    },
  },
  // 是否启用自定义筛选
  isCustomFilter: {
    type: Boolean as PropType<boolean>,
    default: false,
  },
  // 自定义模块id
  moduleType: { type: Number as PropType<number>, default: () => 0 },
  // 是否显示高级搜索
  filter: {
    type: Boolean as PropType<boolean>,
    default: false,
  },
  // 是否显示
  search: {
    type: Boolean as PropType<boolean>,
    default: false,
  },
  searchConfig: {
    type: Object as PropType<SearchConfig>,
    default: (): SearchConfig => {
      return { prop: 'value', placeholder: '搜索',maxlength:30 ,inputType: 'text',maxsize:''};
    },
  },
  columOptions: {
    type: Array as PropType<ErpTableOptions[]>,
    default: () => {
      return [];
    },
  },
  url: {
    type: String as PropType<string>,
    default: () => {
      return '';
    },
  },
  isPage: {
    type: Boolean as PropType<boolean>,
    default: true,
  },
  // 是否显示分页数据
  showPage: {
    type: Boolean as PropType<boolean>,
    default: true,
  },
  // 是否滚动加载
  isScroll: {
    type: Boolean as PropType<boolean>,
    default: false,
  },
  pageClass: {
    type: String as PropType<string>,
    default: 'footer-pager',
  },
  queryParams: {
    type: Object as PropType<any>,
    default: () => {
      return null;
    },
  },
  // 是否默认请求
  defaultRequest: {
    type: Boolean as PropType<boolean>,
    default: true,
  },
  requestType: {
    type: String as PropType<string>,
    default: 'post',
  },
  isFirstCurrentRow: {
    type: Boolean as PropType<boolean>,
    default: true,
  },
  isReq: {
    type: Boolean as PropType<boolean>,
    default: false,
  },
  seqTitle: {
    type: String as PropType<string>,
    default: '序号',
  },
  pageSize: {
    type: Number as PropType<number>,
    default: 15,
  },
  // 控制表格页脚按钮的数量
  pageCount: {
    type: Number as PropType<number>,
    default: 5,
  },
  currentKey: {
    type: String as PropType<string>,
    default: () => {
      return 'id';
    },
  },
  autoResize: {
    type: Boolean as PropType<boolean>,
    default: false,
  },
  // 获取接口数据的数据结构的key，目前只在库存查询在库库存中有
  tableListKey: {
    type: String as PropType<string | null>,
    default: null,
  },
  //是否显示多选框
  ischeckBox: {
    type: Boolean as PropType<boolean>,
    default: false,
  },
  //多选框信息
  // checkBoxTitle: {
  //   type: String as PropType<string>,
  //   default: '',
  // },
  // 是否顶部显示
  isBackTop: {
    type: Boolean as PropType<boolean>,
    default: false,
  },
  isCustomRender: {
    //是否是自定义表单列表渲染 只用在期货跟进内外贸跟进
    type: Boolean as PropType<boolean>,
    default: false,
  },
  isShowCheckCount: {
    //是否显示勾选的数量
    type: Boolean as PropType<boolean>,
    default: true,
  },
  checkBoxWidth: {
    //是否显示勾选的数量
    type: Number as PropType<number>,
    default: 60,
  },
  isAutoRefresh: {
    //是否修改params-query自动刷新
    type: Boolean,
    default: true,
  },
  isUseSelfDieData: {
    // 是否使用增加固定传入的 list
    type: Boolean,
    default: false,
  }
};
export default skTableProps;
